public class Board
{
	Square[][] squares;
	int height,width,players,turn,move,
	incriment,initialTime,currentTime,
	lastX,lastY,max,
	progressiveMoves,
	numberOfPieceTypes,
	forceWin;
	String boardName,gameType;
	boolean randomized,needSuicideCapture,noCheck;
	int[] direction,points;
	Hand hand;
	
	public Board(){}
	public Board returnClone()
	{	Board b=new Board();
		int i,j;
		b.squares=new Square[height][width];
		for(i=0;i<height;i++)
			for(j=0;j<width;j++)
				b.setSquare(i,j,square(i, j).returnClone(b));
		b.height=height;b.width=width;b.players=players;
		b.turn=turn;b.move=move;b.lastX=lastX;b.lastY=lastY;
		b.incriment=incriment;b.initialTime=initialTime;b.currentTime=currentTime;
		b.max=max;b.forceWin=forceWin;b.progressiveMoves=progressiveMoves;
		b.numberOfPieceTypes=numberOfPieceTypes;b.boardName=boardName;
		b.gameType=gameType;b.randomized=randomized;
		b.needSuicideCapture=needSuicideCapture;b.noCheck=noCheck;
		if(stuffCanBeDropped())b.hand=new Hand(hand);
		int[] dir=direction;
		b.direction=new int[dir.length];
		for(i=0;i<dir.length;i++)b.direction[i]=dir[i];
		int[] pts=points;
		b.points=new int[pts.length];
		for(i=0;i<dir.length;i++)points[i]=pts[i];
		return b;
	}
	public boolean equals(Board b)
	{	if(b.height!=height||b.width!=width)
			return false;
		for(int i=0;i<height;i++)
			for(int j=0;j<width;j++)
				if(!square(i,j).equals(b.square(i, j)))
					return false;
		if(move!=b.move)return false;
		return true;
	}
	
	public boolean gameOver()
	{	if(forceWin!=0)return true;
		int t=countKings(),i=1;
		String gt=gameType;
		if(!alternateWin()&&t>1)
			for(;i<=players;i++)
				if(!hasKing(i))
					removePlayer(i);
		if(gt.equals("Extinction"))
		{	for(;i<=players;i++)
				if(countPieceTypes(i)<numberOfPieceTypes)
					return true;
		}else if(gt.equals("Partners"))
		{	if(t<3)return true;
		}else if(gt.equals("Peasant"))
		{	for(;i<=players;i++)
				if(!hasPiece("Pawn",i))
					return true;
		}
		else if((gt.equals("Assassination")||gt.equals("Revenge"))&&t<players)
			return true;
		else
		{	if(t<=1&&!alternateWin())return true;
			if(inCheckmate()&&players==2)return true;
		}
		return false;
	}
	public void move(int i, int j, int x, int y)
	{	Square s1=square(i,j),s2=square(x,y);
		String n1=s1.name,n2=s2.name,gt;
		int c2=s2.color;
		gt=gameType;
		lastX=x;lastY=y;
		boolean empt=s2.empty(),
			capt=!empt&&!(n1.equals("Penguin")||n1.equals("Tank")),
			wasCastling=s1.canCastle(x,y);
		boolean aColoredCapture=c2!=5&&capt;
		if(n1.equals("Tank"))
		{	pushWithTank(i,j,x,y);
			s1.hasMoved=true;
		}else if(gt.equals("Rifles")&&!s2.empty())
		{	lastX=i;lastY=j;
			kill(x,y);
			s1.hasMoved=true;
		}else
		{	moveOnly(i,j,x,y);
			s1.hasMoved=true;
			if(aColoredCapture)
			{	if(gt.equals("Absorption"))s2.name=n2;
				if(gt.equals("Crazyhouse")||
						gt.equals("Crazyhouse Four Player")&&!n2.equals("King"))
					hand.addCapture(n2, turn);
			}
			if (capt)
			{	if(gt.equals("Gold Rush"))points[turn]++;
				if(gt.equals("Atomic"))explode(x,y);
			}
		}
		if(n1.equals("Penguin"))spawnPiece(i,j,n2,c2);
		if(wasCastling)
		{	if(turn==1||turn==2)
			{	if(j<y)moveOnly(x,y+1,x,y-1);
				else moveOnly(x,y-2,x,y+1);
			}else
			{	if(i<x)moveOnly(x+1,y,x-1,y);
				else moveOnly(x-2,y,x+1,y);
			}
		}
		if(gt.equals("Magnetic"))magnatize(x, y);
		if(capt&&(n1.equals("Phoenix"))||n2.equals("Grenade"))
			kill(x,y);
		endTurn();
	}
	public void endTurn()
	{	if(gameType.equals("Suicide"))updateSuicideCapture();
		if(!gameOver())
		{	if(!gameType.equals("Progressive"))
			{	if(turn==players)
				{	turn=1;
					move++;
				}else turn++;
				if(!hasKing(turn)&&!alternateWin())endTurn();
			}else
			{	progressiveMoves++;
				Board b=returnClone();
				if(turn==players)b.turn=1;
				else b.turn++;
				boolean checked=b.inCheck();
				if(progressiveMoves==move||checked)
				{	progressiveMoves=0;
					move++;
					if(turn==players)turn=1;
					else turn++;
				}
			}
			if(gameType.equals("Suicide"))updateSuicideCapture();
			promotePawns();
		}
	}
	public void resign(int c)
	{	if(players==4)
		{	removePlayer(c);
			if(!gameOver()&&turn==c)endTurn();
		}else
		{	if(c==1)forceWin=2;
			if(c==2)forceWin=1;
		}
	}
	public void draw()
	{	forceWin=5;
	}
	public void drop(String type, int i, int j)
	{	spawnPiece(i, j, type, turn);
		square(i,j).hasMoved=true;
		hand.drop(type, turn);
		endTurn();
	}
	public int countKings()
	{	int t=0,i=1;
		for(;i<=players;i++)
			if(hasKing(i))t++;
		return t;
	}
	public Square square(int x, int y)
	{	return squares[x][y];
	}
	public void setSquare(int x, int y, Square s)
	{	squares[x][y]=s;
	}
	public void removePlayer(int c)
	{	for(int i=0;i<height;i++)
			for(int j=0;j<width;j++)
				if(square(i,j).color==c)
					kill(i,j);
	}
	public boolean alternateWin()
	{	return gameType.equals("Extinction")||gameType.equals("Peasant")||
		gameType.equals("Suicide");
	}
	public boolean canMove(int i, int j, int x, int y)
	{	if(gameType.equals("Absorption"))
		{	Square sq=square(i,j);
			if(!sq.name.equals("Farm")&&sq.nextToForAbsorption())
			{	if(sq.name.equals("Pawn"))
					if(!Square.squareInRange(x, y, i, j, 2))
						return false;
				String tempName=sq.name;
				sq.name="Doppelganger";
				boolean ret=sq.canMove(x, y);
				sq.name=tempName;
				return ret;
			}
		}
		if(noCheck||alternateWin())
			return square(i,j).canMoveNoCheckTest(x,y);
		return square(i,j).canMove(x, y);
	}
	public boolean canDrop(String s, int i, int j)
	{	if(!square(i,j).empty())return false;
		String gt=gameType;
		if(!stuffCanBeDropped())return false;
		if(!hand.inHand(s, turn))return false;
		if(s.equals("Pawn")&&i==0||i==height-1)
		if(gt.equals("Paratrooper"))
		{	if(turn==1&&i<height/2)return false;
			if(turn==2&&i>=height/2)return false;
		}
		return true;
	}
	public boolean stuffCanBeDropped()
	{	String gt=gameType;
		return gt.equals("Crazyhouse")||
		gt.equals("Crazyhouse Four Player")||gt.equals("Bughouse")||
		gt.equals("Paratrooper")||gt.equals("Setup Position");
	}
	public void kill(int i, int j)
	{	spawnPiece(i,j,"Empty",0);
	}
	public void moveOnly(int i, int j, int x, int y)
	{	setSquare(x, y, square(i, j));
		squares[x][y].setXY(x, y);
		kill(i, j);
	}
	public boolean hasPiece(String t,int c)
	{	for(int i=0;i<height;i++)
			for(int j=0;j<width;j++)
			{	Square s=square(i,j);
				if(s.name.equals(t)&&s.color==c)
					return true;
			}
		return false;
	}
	public boolean hasKing(int c)
	{	return hasPiece("King",c);
	}
	public int whoWon()
	{	int p;
		String gt=gameType;
		if(forceWin!=0)return forceWin;
		if(gt.equals("Chaos"))
		{	int ammt=0;
			for(int i=1;i<points.length;i++)ammt+=points[i];
			if(ammt!=0)
			{	for(p=1;p<=2;p++)
				{	int pts=points[p];
					if(pts==2)return p;
				}
				return 5;
			}
		}
		if(gt.equals("Extinction"))
		{	int p1=countPieceTypes(1),p2=countPieceTypes(2);
			if(p1>p2)return 1;
			if(p1<p2)return 2;
		}
		else if(gt.equals("Gold Rush"))
		{	int best=0;
			for(p=1;p<=4;p++)
				if(points[p]>best)
					best=p;
			return best;
		}else if(gt.equals("Peasant"))
		{	if(hasPiece("Pawn", 1))return 1;
			if(hasPiece("Pawn", 2))return 2;
		}
		else if(gt.equals("Suicide"))
		{	return turn;
		}
		else if(players==2)
		{	if(!hasKing(1))return 2;
			if(!hasKing(2))return 1;
			if(inCheckmate())
			{	if(turn==1)return 2;
				if(turn==2)return 1;
			}
		}
		else if(players==4)
		{	for(p=1;p<=4;p++)
			{	if(!hasKing(p))
				{	if(gt.equals("Assasination"))
					{	if(p==1)return 4;
						if(p==2)return 3;
						if(p==3)return 1;
						if(p==4)return 2;
					}
					if(gt.equals("Revenge"))
					{	if(p==1)return 2;
						if(p==2)return 1;
						if(p==3)return 4;
						if(p==4)return 3;
					}
				}else
				{	return p;
				}
			}
		}
		return 0;
	}
	public void spawnPiece(int i, int j, String type, int c)
	{	setSquare(i, j, new Square(i, j, this, c, type));
	}
	public boolean onBoard(int i, int j)
	{	if(i<0||j<0)return false;
		return !(i>=height||j>=width);
	}
	
	//Special Effects
	public void magnatize(int i, int j)
	{	int[] dir1={0,1,2,3};
		int[] dir2={1,0,3,2};
		boolean[] found={false,false,false,false};
		for(int x=1;x<max;x++)
			for(int c=0;c<4;c++)
			{	int t=0,g=0;
				if(c==0){t=i-x;g=j;}
				if(c==1){t=i+x;g=j;}
				if(c==2){t=i;g=j-x;}
				if(c==3){t=i;g=j+x;}
				if(onBoard(t,g)&&!found[c])
				{	Square pf=square(t, g);
					if(!square(t, g).empty())
					{	found[c]=true;
						if(pf.color==turn)push(t,g,dir1[c]);
						else push(t,g,dir2[c]);
					}	
				}
			}
	}
	public void push(int i, int j, int dir)
	{	int c,x=0,y=0,t1=i,t2=j;
		boolean ended=false;
		for(c=1;!ended;c++)
		{	if(dir==0){x=i-c;y=j;}
			if(dir==1){x=i+c;y=j;}
			if(dir==2){x=i;y=j-c;}
			if(dir==3){x=i;y=j+c;}
			if(onBoard(x, y))
			{	if(square(x, y).empty()&&onBoard(x, y))
					moveOnly(t1, t2, x, y);
				else ended=true;
			}else ended=true;
			t1=x;t2=y;
		}
	}
	public void promotePawns()
	{	int x,y,d;
		for(x=0;x<height;x++)
			for(y=0;y<width;y++)
				{	Square sq=square(x, y);
					if(sq.name.equals("Pawn"))
					{	d=direction[sq.color];
						if(d==1&&x==0)sq.name="Queen";
						if(d==2&&x==height-1)sq.name="Queen";
						if(d==3&&y==0)sq.name="Queen";
						if(d==4&&y==width-1)sq.name="Queen";
					}
				}
	}
	public boolean canSee(int i, int j, int c)
	{	if(square(i,j).color==c)
			return true;
		return squareProtected(i, j, c);
	}
	public boolean squareProtected(int i, int j, int c)
	{	int a,b;
		for(a=0;a<height;a++)
			for(b=0;b<width;b++)
				if(canMove(a,b,i,j))return true;
		return false;
	}
	public boolean canMakeACapture()
	{	int a,b,i,j;Square sq;
		for(a=0;a<height;a++)
			for(b=0;b<width;b++)
			{	sq=square(a,b);
				if(sq.isMoveable())
					if(!sq.name.equals("Penguin")&&!sq.name.equals("Tank"))
						for(i=0;i<height;i++)
							for(j=0;j<width;j++)
								if(!square(i,j).empty())
									if(canMove(a,b,i,j))
										return true;
			}
		return false;
	}
	public void explode(int x, int y)
	{	for(int a=x-1;a<=x+1;a++)
			for(int b=y-1;b<=y+1;b++)
				if(onBoard(a,b))
				{	boolean pawn=square(a,b).name.equals("Pawn"),same;
					same=a==x&&b==y;
					if(same)kill(a,b);
					else if(!pawn)kill(a,b);
				}
	}
	public int attacker(int i)
	{	if(gameType.equals("Assassination"))
		{	if(i==1)return 4;
			if(i==2)return 3;
			if(i==3)return 1;
			if(i==4)return 2;
		}else if(gameType.equals("Revenge"))
		{	if(i==1)return 2;
			if(i==2)return 1;
			if(i==3)return 4;
			if(i==4)return 3;
		}
		return 0;
	}
	public int countPieceTypes(int c)
	{	int r=0,i;
		String[] p={"Rook","Knight","Bishop","Queen","King",
				"Penguin","Phoenix","Psychic","Chicken","Tank",
				"Grenade","Doppelganger","Lover","Pawn"};
		for(i=0;i<p.length;i++)
			if(hasPiece(p[i],c))r++;
		return r;
	}
	public boolean inCheckmate()
	{	int a,b,i,j;
		for(a=0;a<height;a++)
			for(b=0;b<width;b++)
				if(square(a,b).isMoveable())
					for(i=0;i<height;i++)
						for(j=0;j<width;j++)
							if(canMove(a,b,i,j))
								return false;
		return true;
	}
	public boolean inCheck()
	{	int r,t,i,j,savedTurn=turn,c;
		Square sq,sq2;
		for(r=0;r<height;r++)
			for(t=0;t<width;t++)
			{	sq=square(r, t);
				c=sq.color;
				String n=sq.name;
				if(c!=0&&c!=5&&!n.equals("Penguin")&&!n.equals("Tank"))
				{	turn=c;
					if(sq.isMoveable())
						for(i=0;i<height;i++)
							for(j=0;j<width;j++)
							{	sq2=square(i, j);
								if(sq2.name.equals("King")&&sq2.color==savedTurn)
									if(canMove(r,t,i,j))
									{	turn=savedTurn;
										return true;
									}
							}
				}
			}
		turn=savedTurn;
		return false;
	}
	public boolean canCapture(int c1, int c2)
	{	String gt=gameType;
		if(c1==0)return false;
		if(gt.equals("Partners"))
		{	if(c1==1&&c2==2)return false;
			if(c1==2&&c2==1)return false;
			if(c1==3&&c2==4)return false;
			if(c1==4&&c2==3)return false;
		}
		if(gt.equals("Revenge"))
		{	if(c1==1&&c2!=2)return false;
			if(c1==2&&c2!=1)return false;
			if(c1==3&&c2!=4)return false;
			if(c1==4&&c2!=3)return false;
		}
		return true;
	}
	public void pushWithTank(int i, int j, int x, int y)
	{	int nextX=2*x-i,nextY=2*y-j;
		if(onBoard(x,y))
			if(square(x,y).empty())
				moveOnly(i,j,x,y);
			else
			{	pushWithTank(x,y,nextX,nextY);
				moveOnly(i,j,x,y);
			}	
	}
	public static String colorGen(int c)
	{	if(c==1)return "Red";
		if(c==2)return "Black";
		if(c==3)return "Blue";
		if(c==4)return "Green";
		if(c==5)return "Neutral";
		return "Empty";
	}
	public int anyMoves(int i, int j)
	{	Square sq=square(i,j);
		if(sq.empty())return 0;
		if(!sq.isMoveable())return 0;
		int a,b,ret=0;
		for(a=0;a<height;a++)
			for(b=0;b<width;b++)
				if(canMove(i,j,a,b))
					ret++;
		return ret;
	}
	public void updateSuicideCapture()
	{	needSuicideCapture=false;
		gameType="Regular";
		if(canMakeACapture())needSuicideCapture=true;
		gameType="Suicide";
	}
	public String message()
	{	String r="";
		if(!gameOver())
		{	r+="Playing "+gameType+" Chess - "+
			colorGen(turn)+"'s Turn, Move: "+move;
			if(gameType.equals("Gold Rush"))
			{	r+=" Points:";
				for(int i=1;i<=4;i++)
					r+=" "+colorGen(i)+": "+points[i];
				r+=".";
			}else if(!alternateWin())
			{	if(inCheck())r+=" Check!";
				else r+=".";
			}
			else r+=".";
		}else
		{	int w=whoWon();
			if(w==5)r="Game drawn.";
			else r="Game over, "+colorGen(w)+" has won the game!";
		}
		return r;
	}
	public String squareStrings()
	{	String ret="";
		for(int i=0;i<height;i++)
			for(int j=0;j<width;j++)
				ret+=square(i,j).color+" "+square(i,j).name+"\n";
		return ret;
	}
}
