import java.awt.*;
import java.awt.event.*;
import javax.swing.JPanel;

public class BoardPanel extends JPanel implements MouseListener
{	static final long serialVersionUID=(long)0.0;
	boolean selected,flipped;
	int squareSize,boardSize,height,width,
	selectedX,selectedY,vAdditional,
	hAdditional,selectedCol,textExtra;
	Image[][] images,showImages;
	Color[][] showColors;
	String dropType;
	Client client;
	GameWindow gameWindow;
	Color fill,dark,light,chosen,possible,handCol,moved;
	public BoardPanel(int bs,Client c,GameWindow g)
	{	client=c;
		gameWindow=g;
		initializeImages(board().players,board().height,board().width);
		dark=new Color(125,38,205);
		light=new Color(255,222,173);
		moved=new Color(202,255,112);
		possible=new Color(99,184,255);
		handCol=new Color(238,238,238);
		chosen=moved;
		setFont(new Font("Info",Font.BOLD,14));
		addMouseListener(this);
		setSize(bs);
		selected=false;
		flipped=false;
		dropType="";
		selectedX=99;selectedY=99;
		showColors=new Color[board().height][board().width];
		showImages=new Image[board().height][board().width];
	}
	public Board board()
	{	return gameWindow.board;
	}
	public void setSize(int bs)
	{	boardSize=bs;
		squareSize=boardSize/board().height;
		height=board().height*squareSize;
		width=board().width*squareSize;
		hAdditional=0;
		textExtra=15;
		if(board().stuffCanBeDropped())
			hAdditional=(squareSize+textExtra*2)*board().players/2;
		width+=hAdditional;
	}
	public void paint(Graphics g)
	{	gameWindow.resetTheSize();
		int i,j,s=squareSize,endOfBoard=width-hAdditional;
		if(board().gameOver()&&board().gameType.equals("Chaos"))
		{	int ammt=0;
			for(i=1;i<board().points.length;i++)ammt+=board().points[i];
			if(ammt==0)
			{	int winner=board().whoWon();
				gameWindow.board=gameWindow.log.startingPosition.returnClone();
				gameWindow.log.addMove(board());
				selected=false;
				board().points[winner]++;
			}
		}
		gameWindow.msg.setText(board().message());
		updateImagesAndColors();
		setSize(width,height);
		for(i=0;i<board().height;i++)
			for(j=0;j<board().width;j++)
				g.drawImage(showImages[i][j],j*s,
						i*s,s,s,showColors[i][j],this);
		if(board().stuffCanBeDropped())
		{	g.drawImage(transparent(),endOfBoard,0,
					hAdditional,height,handCol,this);
			for(i=1;i<=board().players;i++)
			{	int found=0;
				if(!board().hand.empty())
					for(j=0;j<15;j++)
					{	int ammount,imgX,imgY,hs=s/2;
						ammount=board().hand.playersPieces[i][j];
						if(ammount!=0)
						{	imgX=endOfBoard+((s+textExtra*2)*(i-1))/2;
							imgY=found*hs;
							String hpn=(String)board().hand.pieceNames.get(j);
							Color pc=handCol;
							if(selectedX==888&&selectedY==found
									&&selected&&selectedCol==i)
								pc=chosen;
							g.drawImage(image2(hpn,i),imgX,imgY,
								hs+textExtra,hs,pc,this);
							if(ammount!=1)g.drawString(
									ammount+"",imgX+hs,imgY+hs/2);
							found++;
						}
					}
				}
		}
	}
	public void mousePressed(MouseEvent e){}
	public void mouseReleased(MouseEvent e){}
	public void mouseEntered(MouseEvent e){}
	public void mouseExited(MouseEvent e){}
	public void mouseClicked(MouseEvent e)
	{	if(gameWindow.myTurn())
		{	int getX=e.getX(),getY=e.getY();
			if(!board().gameOver())
			{	if(getX<=width-hAdditional)
				{	int x,y,sx,sy,any;
					sx=selectedX;sy=selectedY;
					x=getY/squareSize;y=getX/squareSize;
					if(flipped)
					{	x=board().height-x-1;
						y=board().width-y-1;
					}
					any=board().anyMoves(x,y);
					if(selected)
					{	selected=false;
						if(!(sx==x&&sy==y))
						{	if(sx==888)
							{	if(board().canDrop(dropType,x,y))
									client.sendDrop(dropType,x,y);
								else if(any>0)select(x,y);
							}else
							{	if(board().canMove(sx,sy,x,y))
									client.sendClicks(sx,sy,x,y);
								else if(any>0)select(x,y);
							}
						}
					}else if(any>0)select(x,y);
				}else
				{	int endBoard,col,hsh,hsv,sqsFromTop,j,found,ammt;
					endBoard=width-hAdditional;
					hsv=squareSize/2;hsh=hsv+textExtra;
					col=(getX-endBoard)/hsh+1;
					sqsFromTop=(getY)/hsv;
					if(sqsFromTop>=board().hand.ammountInHand(col));
					{	for(j=0,found=0;j<15;j++)
						{	ammt=board().hand.playersPieces[col][j];
							if(ammt!=0)
							{	if(found==sqsFromTop)
								{	dropType=(String)board().hand.pieceNames.get(j);
								}
								found++;
							}
						}
						boolean oldSel=selected,rc=col==board().turn;
						selected=false;
						if((selectedY!=sqsFromTop||!oldSel)&&rc)
							selectDrop(sqsFromTop,col);
					}
				}
				repaint();
			}
		}
	}
	public void flipBoard()
	{	if(flipped)flipped=false;
		else flipped=true;
		repaint();
	}
	public void updateImagesAndColors()
	{	int i,j,x,y;
		for(i=0;i<board().height;i++)
			for(j=0;j<board().width;j++)
			{	if(flipped)
				{	x=board().height-i-1;
					y=board().width-j-1;
				}else
				{	x=i;y=j;
				}
				showColors[i][j]=squareColor(x,y);
				if(board().gameType.equals("Fog of War"))
				{	if(!board().canSee(x,y,board().turn))
						showImages[i][j]=transparent();
				}
				else showImages[i][j]=image(x,y);
			}
	}
	public void select(int x,int y)
	{	selected=true;
		selectedX=x;selectedY=y;
	}
	public void selectDrop(int y,int c)
	{	selected=true;
		selectedX=888;selectedY=y;
		selectedCol=c;
	}
	public Color squareColor(int x,int y)
	{	int sx=selectedX,sy=selectedY;
		fill=dark;
		if((x+y)%2==0)fill=light;
		if(x==board().lastX&&y==board().lastY)fill=moved;
		if(selected&&sx!=888)
		{	if(x==sx&&y==sy)fill=chosen;
			else if(board().canMove(sx,sy,x,y))fill=possible;
		}
		return fill;
	}
	public Image image(int x,int y)
	{	return image2(square(x,y).name,square(x,y).color);
	}
	public Image image2(String n,int c)
	{	int j,ni=images.length-1;
		if(n.equals("Empty"))return transparent();
		String[] p={"Rook","Knight","Bishop","Queen","King",
				"Penguin","Phoenix","Psychic","Lover","Tank",
				"Grenade","Doppelganger","Chicken","Pawn","Farm"};
		for(j=0;j<15;j++)
			if(p[j].equals(n))return images[c-1][j];
		if(n.equals("Gold Coin"))return images[ni][0];
		if(n.equals("Mountain"))return images[ni][1];
		if(n.equals("Soccer Ball"))return images[ni][2];
		return transparent();
	}
	public Square square(int x,int y)
	{	return board().square(x, y);
	}
	public String colorString(Color c)
	{	return String.valueOf(c.getRed());
	}
	public Image transparent()
	{	return images[images.length-1][2];
	}
	public Image getImage(String s)
	{	return Toolkit.getDefaultToolkit().getImage(s);
	}
	public void initializeImages(int pl,int h,int w)
	{	String[] p={"Rook","Knight","Bishop","Queen","King",
			"Penguin","Phoenix","Psychic","Lover","Tank",
			"Grenade","Doppelganger","Chicken","Pawn","Farm"};
		if(pl==4)images=new Image[5][15];
		else images=new Image[3][15];
		int i,j,ni=images.length-1;
		for(i=0;i<pl;i++)
		{	String s=client.visualOptions.imagePath
			+Board.colorGen(i+1)+"/";
			for(j=0;j<15;j++)
				images[i][j]=getImage(s+p[j]+".gif");
		}
		String neut="Images/Neutral/";
		images[ni][0]=getImage(neut+"Gold Coin"+".gif");
		images[ni][1]=getImage(neut+"Mountain"+".gif");
		images[ni][2]=getImage(neut+"Transparent"+".gif");
	}
}