import java.net.*;
import java.io.*;
import javax.swing.*;
import java.util.ArrayList;

public class Client implements Runnable
{	public static void main(String[] args)
	{	Client c=new Client();
		c.start();
	}
	GameWindow gameWindow;
	Socket connection;
	DataInputStream input;
	DataOutputStream output;
	Thread outputThread;
	int ci,cj,cx,cy;
	String name,dropType;
	Console console;
	ArrayList confirmDialogs;
	VisualOptionsWindow visualOptions;
	//DebugWindow debug;
	static final long serialVersionUID=(long)0.0;
	public Client()
	{	
	}
	public void start()
	{	try
		{	connection=new Socket(
				InetAddress.getByName("127.0.0.1"),8008);
        	input=new DataInputStream(connection.getInputStream());
        	output=new DataOutputStream(connection.getOutputStream());
		}
		catch(IOException e)
		{	e.printStackTrace();         
		}
		outputThread=new Thread(this);
		outputThread.start();
	}
	public void run()
	{	//debug=new DebugWindow("Client Debugging");
		String h="",initialSeeks,initialPlayers;
		visualOptions=new VisualOptionsWindow();
		while(h.length()<4||h.length()>12)
			h=JOptionPane.showInputDialog(
				null,"Please enter a handle 4-12 characters long.");
		sendString(h);
		name=h;
		initialSeeks=getString();
		initialPlayers=getString();
		console=new Console(this,initialSeeks,initialPlayers);
		confirmDialogs=new ArrayList();
		while(true)
		{	String s=getString();
			processMessage(s);
		}
	}
	public void processMessage(String s)
	{	if(s.equals("Valid"))
		{	if(ci==99&&cj==99)
				gameWindow.makeDrop(cx,cy,dropType);
			else gameWindow.makeMove(ci,cj,cx,cy);
		}else if(s.equals("Opponent moved"))
		{	int i,j,x,y;
			i=getInt();
			j=getInt();
			x=getInt();
			y=getInt();
			String dt=getString();
			if(i==99&&j==99)
				gameWindow.makeDrop(x,y,dt);
			else gameWindow.makeMove(i,j,x,y);
		}else if(s.equals("Game Started"))
		{	int p=getInt();
			String board,type;
			board=getString();
			boolean rand=getBoolean();
			type=getString();
			Board b;
			if(rand)
			{	int l=getInt();
				String[] pieces=new String[l];
				for(int i=0;i<l;i++)pieces[i]=getString();
				b=SavedBoards.genFromStrings(board,rand,type,pieces);
			}else b=SavedBoards.genFromStrings(board,rand,type);
			String pl=getString();
			newGame(b,p,pl);
		}else if(s.equals("Game Aborted"))
		{	popup(
			"Game aborted.");
			gameWindow.setVisible(false);
		}else if(s.equals("Game Drawn"))
		{	gameWindow.draw();
		}
		else if(s.equals("Takeback Request"))
		{	int allow=JOptionPane.showConfirmDialog(null,
			"Your opponent has requested and undo."
				+"\nDo you wish to allow this?",
			"Undo the last move?",JOptionPane.YES_NO_OPTION);
			if(allow==JOptionPane.YES_OPTION)
				sendString("Takeback Accepted");
		}else if(s.equals("Draw Offer"))
		{	int allow=JOptionPane.showConfirmDialog(null,
			"Your opponent has offered a draw."
				+"\nDo you accept?",
			"Accept Draw Offer?",JOptionPane.YES_NO_OPTION);
			if(allow==JOptionPane.YES_OPTION)
				sendString("Draw Accepted");
		}
		else if(s.equals("Resign"))
		{	gameWindow.playerResigned(getInt());
		}else if(s.equals("Game Over"))
		{	String message=getString();
			popup(message);
			gameWindow.setVisible(false);
		}else if(s.equals("Move Taken Back"))
		{	gameWindow.takeBackMove(getInt());
		}else if(s.equals("You Added A Seek"))
		{	int n=getInt();
			String gt=getString(),mp;
			mp=getString();
			boolean r=getBoolean();
			confirmDialogs.add(new ConfirmDialog(this,n,gt,mp,r));
		}else if(s.equals("Seek Declined"))
		{	String p=getString(),g,m;
			g=getString();
			m=getString();
			popup(p+" declined to play you in ("+g+" "+m+").");
		}
		else if(s.equals("Player Accepted"))
		{	int numb=getInt();
			String accName=getString();
			for(int j=0;j<confirmDialogs.size();j++)
			{	ConfirmDialog g=(ConfirmDialog)confirmDialogs.get(j);
				if(g.number==numb)g.challenger(accName);
			}
		}else if(s.equals("Players Updated"))
		{	String ps=getString();
			console.updatePlayers(ps);
		}else if(s.equals("Seeks Updated"))
		{	String ps=getString();
			console.updateSeeks(ps);
		}else if(s.equals("Chat"))
			display(getString());
		else if(s.equals("Game Chat"))
			gameWindow.display(getString());
		else popup(s);
	}
	public void sendClicks(int i,int j,int x,int y)
	{	if(gameWindow.myTurn())
		{	ci=i;cj=j;cx=x;cy=y;
			dropType="";
			sendString("Move");
			sendInt(i);
			sendInt(j);
			sendInt(x);
			sendInt(y);
			sendString("N/A");
		}
	}
	public void sendDrop(String type,int x,int y)
	{	if(gameWindow.myTurn())
		{	ci=99;cj=99;cx=x;cy=y;
			dropType=type;
			sendString("Move");
			sendInt(99);
			sendInt(99);
			sendInt(x);
			sendInt(y);
			sendString(type);
		}
	}
	public void display(String s)
	{	console.display(s);
	}
	public void popup(String s)
	{	JOptionPane.showMessageDialog(null,s);
	}
	public void chat(String s)
	{	sendString("Chat");
		sendString(s);
	}
	public void gameChat(String s)
	{	sendString("Game Chat");
		sendString(s);
	}
	public void newGame(Board b,int p,String pl)
	{	gameWindow=new GameWindow(b,this,p,pl);
		if(gameWindow.player==2)
		gameWindow.boardPanel.flipBoard();
	}
	public void resign()
	{	sendString("Resign");
	}
	public void offerDraw()
	{	sendString("Draw Offer");
	}
	public void takeBackMoveRequest()
	{	sendString("Take Back Request");
	}
	public void sendSeek(String n,String m,boolean r)
	{	sendString("Seek");
		sendString(n);
		sendString(m);
		sendBoolean(r);
	}
	public void accpetSeek(int n)
	{	sendString("Accept Seek");
		sendInt(n);
	}
	public void withdrawSeek(int n)
	{	sendString("Withdraw Seek");
		sendInt(n);
	}
	public void seekConfirmed(int n,String p)
	{	sendString("Seek Confirmed");
		sendInt(n);
		sendString(p);
	}
	public void seekDeclined(int n,String p)
	{	sendString("Seek Declined");
		sendInt(n);
		sendString(p);
	}
	public void sendString(String s)
	{	try 
		{	//debug.addOutput(s);
			output.writeUTF(s);
		}catch(IOException e)
		{	quit();
		}
	}
	public void sendInt(int i)
	{	try 
		{	//debug.addOutput(i+"");
			output.writeInt(i);
		}catch(IOException e)
		{	quit();
		}
	}
	public void sendBoolean(boolean b)
	{	try 
		{	//debug.addOutput(b+"");
			output.writeBoolean(b);
		}catch(IOException e)
		{	quit();
		}
	}
	public String getString()
	{	try 
		{	String i=input.readUTF();
			//debug.addInput(i);
			return i;
		}catch(IOException e)
		{	quit();
			return "Error";
		}
	}
	public int getInt()
	{	try 
		{	int i=input.readInt();
			//debug.addInput(i+"");
			return i;
		}catch(IOException e)
		{	quit();
			return -1;
		}
	}
	public boolean getBoolean()
	{	try 
		{	boolean b=input.readBoolean();
			//debug.addInput(b+"");
			return b;
		}catch(IOException e)
		{	quit();
			return false;
		}
	}
	public void quit()
	{	System.exit(0);
	}
}