import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;

public class Console extends JFrame
{	Client client;
	JTextArea display;
	JTextField textEntry;
	JPanel text;
	SeekList seeks;
	PlayerList players;
	JMenuItem newGame,quit,gameOptions,visualOptions,gameHelp,about;
	JMenuBar mb=new JMenuBar();
	JMenu file,options,help;

	static final long serialVersionUID=(long)0.0;
	public Console(Client cli,String initalSeeks,String initialPlayers)
	{	super("FIGS");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		client=cli;
		seeks=new SeekList(initalSeeks,this);
		players=new PlayerList(initialPlayers,20);
		display=new JTextArea(20,30);
		display.setLineWrap(true);
		display.setEditable(false);
		display.setForeground(Color.blue);
		JScrollPane displayPane=new JScrollPane(display,
		JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,
		JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		textEntry=new JTextField();
		textEntry.setEnabled(true);
		textEntry.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	String s=textEntry.getText();
				if(!s.equals(""))
				{	textEntry.setText("");
					client.chat(s);
				}
			}
		});
		text=new JPanel();
		text.setLayout(new BorderLayout());
		text.add(displayPane);
		text.add(textEntry,"South");
		newGame=new JMenuItem("New Game");
		quit=new JMenuItem("Quit");
		gameOptions=new JMenuItem("Gameplay Options");
		visualOptions=new JMenuItem("Visual Options");
		gameHelp=new JMenuItem("Contents");
		about=new JMenuItem("About");
		newGame.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	new NewGameMenu(client);
			}
		});
		quit.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	client.quit();
			}
		});
		gameOptions.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	//new gameOptionsMenu();
			}
		});
		visualOptions.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	client.visualOptions.packStuff();
			}
		});
		gameHelp.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	new HelpMenu();
			}
		});
		about.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	new AboutPopup();
			}
		});
		mb=new JMenuBar();
		file=new JMenu("File");
	    options=new JMenu("Options");
	    help=new JMenu("Help");
	    file.add(newGame);
	    file.add(quit);
	    options.add(gameOptions);
	    options.add(visualOptions);
	    help.add(gameHelp);
	    help.add(about);
	    mb.add(file);
	    mb.add(options);
	    mb.add(help);
	    packStuff();
	}
	public void packStuff()
	{	JPanel textAndPlayers=new JPanel();
		textAndPlayers.setLayout(new BorderLayout());
		textAndPlayers.add(text);
		textAndPlayers.add(players,"East");
		Container c=getContentPane();
		c.removeAll();
		c.setLayout(new BorderLayout());
		c.add(seeks);
		c.add(textAndPlayers,"South");
		setJMenuBar(mb);
		pack();
		if(!isVisible())setVisible(true);
		setResizable(false);
	}
	public void display(String s)
	{	display.append(s+"\n");
	}
	public void updatePlayers(String s)
	{	players.update(s);
		packStuff();
	}
	public void updateSeeks(String s)
	{	seeks.update(s);
		packStuff();
	}
}
