import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

public class NewGameMenu extends JFrame
{	static final long serialVersionUID=(long)0.0;
	Client client;
	JList gameList;
	JButton startButton,cancelButton;
	JRadioButton[] twoPlayerBoards,fourPlayerBoards;
	JRadioButton twoPlayer,fourPlayer,twoBoard;
	JPanel radioPanel,choicePanel;
	JCheckBox randomize;
	int chosen;
	MouseListener helpListener;
	JTextArea printMessage;
	String[] messages,
	twoMessages={
	"This is the same as normal chess\nwith three differences:\n1. Stalemate is a loss\n2. You cannot repeat a board position\n3. No en passant",
	"When you capture a piece it goes\ninto your “hand”.  Instead of moving,\nany turn you may drop a piece\non an unoccupied square.",
	"When a capture is made,\nthe capturing piece dies, and all next\nto it except pawns do also",
	"After a piece moves, you look\nin all four directions, if the closest\npiece is a friendly piece push it away\nas far as it can go, if its the opposite\ncolor attract it next to it",
	"Goal is to not be able to move,\nif you can capture you must",
	"First player gets one move,\nsecond two, etc, if you\ngive check turn over",
	"Players can only see what they\nare attacking, and own pieces",
	"You can only move pieces you\nare attacking (including opponents)",
	"Your pieces cannot move backwards,\npieces on back row can move anywhere",
	"When a capture is made, just\nremove the captured piece,\ndo not move the capturing piece",
	"All pieces move like those next to\nthem instead of themselves,\npawns have a max range of 2 squares",
	"Semi-random starting position,\nplay one game as each side,\nred cannot check on first move",
	"All pieces but king start in\nhand, and may only drop on your\nside of the board",
	"If you lose one piece\ntype you lose game",
	"Whoever captures all\npawns first wins",
	}
	,fourMessages={
	"Team win, your partner is across from\nyou, cant capture partners pieces",
	"Each player target is to their\nright, whoever's target dies first wins",
	"When you capture a piece it goes\ninto your “hand”.  Instead of moving,\nyou may drop a piece from your hand onto\nan unoccupied square.",
	"Your pieces cannot move backwards,\npieces on back row can move anywhere",
	"Game ends when only one army left,\nat beginning all empty squares\nbecome gold coins,\nwinner based on points, you get a point\nfor each capture you make",
	"Assassination, but target is across,\nand you cannot capture any pieces\nbut your targets",
	}
	,twoXTwoMessages={
	"Partner plays opposite color,\nwhen you capture a piece your partner gets\nit like in crazyhouse, if one person wins\nthen his team does",
	"Two boards, you play same color as\npartner, if one player wins team win,\nyou may move to respective square on partners\nboard if it is empty",
	};
	public NewGameMenu(Client c)
	{	super("Create a New Game");
		client=c;
		printMessage=new JTextArea();
		printMessage.setEditable(false);
		twoPlayerBoards=new JRadioButton[3];
    	twoPlayerBoards[0]=new JRadioButton("Classic");
    	twoPlayerBoards[1]=new JRadioButton("New Pieces");
    	twoPlayerBoards[2]=new JRadioButton("Doubled");
    	fourPlayerBoards=new JRadioButton[2];
    	fourPlayerBoards[0]=new JRadioButton("Classic Four Player");
    	fourPlayerBoards[1]=new JRadioButton("New Four Player");
    	setToTwoPlayer();
    	randomize=new JCheckBox("Randomize Starting Rows");
    	twoPlayer=new JRadioButton("Two Player");
    	twoPlayer.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
    		{	setToTwoPlayer();
				packStuff();
			}
		});
    	twoPlayer.setEnabled(true);
    	fourPlayer=new JRadioButton("Four Player");
    	fourPlayer.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	setToFourPlayer();
				packStuff();
			}
		});
    	twoBoard=new JRadioButton("Two Board");
    	twoBoard.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	setToTwoBoard();
				packStuff();
			}
		});
    	startButton=new JButton("Begin the Game");
    	startButton.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	client.sendSeek(gameName(),gameMap(),randomized());
    			setVisible(false);
			}
		});
    	cancelButton=new JButton("Cancel");
    	cancelButton.addActionListener(new ActionListener()
    	{	public void actionPerformed(ActionEvent e)
			{	setVisible(false);
			}
		});
    	ButtonGroup group=new ButtonGroup();
    	group.add(twoPlayer);
    	group.add(fourPlayer);
    	group.add(twoBoard);
    	choicePanel=new JPanel(new FlowLayout());
    	choicePanel.add(twoPlayer);
    	choicePanel.add(fourPlayer);
    	choicePanel.add(twoBoard);
    	packStuff();
	}
	public void packStuff()
	{	Container c=getContentPane();
		c.removeAll();
   		c.setLayout(new BorderLayout());
		JPanel okAndCancel=new JPanel();
   		okAndCancel.setLayout(new FlowLayout());
		okAndCancel.add(startButton);
    	okAndCancel.add(cancelButton);
    	JPanel gameAndMap=new JPanel();
    	gameAndMap.setLayout(new FlowLayout());
    	gameAndMap.add(new JScrollPane(gameList));
    	gameAndMap.add(radioPanel);
    	JPanel randAndChange=new JPanel();
    	randAndChange.setLayout(new BorderLayout());
    	randAndChange.add(randomize,"North");
    	randAndChange.add(choicePanel);
    	JPanel okAndChange=new JPanel();
    	okAndChange.setLayout(new BorderLayout());
    	okAndChange.add(randAndChange,"North");
    	okAndChange.add(okAndCancel);
    	c.add(gameAndMap,"North");
    	c.add(printMessage);
    	c.add(okAndChange,"South");
    	pack();
    	setSize(350,320);
    	setResizable(false);
    	setVisible(true);
	}
	public void setToTwoPlayer()
	{	chosen=2;
		String[] games={"Regular","Crazyhouse","Atomic","Magnetic",
    			"Suicide","Progressive","Fog of War","Power",
    			"Checkers","Rifles","Absorption","Chaos",
    			"Paratrooper","Extinction","Peasant"};
    	gameList=new JList(games);
    	gameList.setVisibleRowCount(6);
    	gameList.setSelectedValue(games[0],true);
    	addHelpListener();
    	messages=twoMessages;
    	printMessage.setText(messages[0]);
		ButtonGroup group=new ButtonGroup();
		for(int i=0;i<3;i++)group.add(twoPlayerBoards[i]);
		radioPanel=new JPanel(new GridLayout(0,1));
		for(int i=0;i<3;i++)
			radioPanel.add(twoPlayerBoards[i]);
		twoPlayerBoards[0].setEnabled(true);
	}
	public void setToFourPlayer()
	{	chosen=4;
		String[] games={"Partners","Assassination",
				"Crazyhouse Four Player","Checkers Four Player",
				"Gold Rush","Revenge"};
    	gameList=new JList(games);
    	gameList.setVisibleRowCount(6);
    	gameList.setSelectedValue(games[0],true);
    	addHelpListener();
    	messages=fourMessages;
    	printMessage.setText(messages[0]);
		ButtonGroup group=new ButtonGroup();
		for(int i=0;i<2;i++)group.add(fourPlayerBoards[i]);
		radioPanel=new JPanel(new GridLayout(0,1));
		for(int i=0;i<2;i++)
			radioPanel.add(fourPlayerBoards[i]);
		fourPlayerBoards[0].setEnabled(true);
	}
	public void setToTwoBoard()
	{	chosen=22;
			String[] games={"Bughouse","Team"};
   	gameList=new JList(games);
    	gameList.setVisibleRowCount(6);
	    	gameList.setSelectedValue(games[0],true);
   	addHelpListener();
    	messages=twoXTwoMessages;
    	printMessage.setText(messages[0]);
		ButtonGroup group=new ButtonGroup();
		for(int i=0;i<3;i++)group.add(twoPlayerBoards[i]);
		radioPanel=new JPanel(new GridLayout(0,1));
		for(int i=0;i<3;i++)
			radioPanel.add(twoPlayerBoards[i]);
		twoPlayerBoards[0].setEnabled(true);
	}
	public void addHelpListener()
	{	helpListener=new MouseListener()
		{	public void mouseClicked(MouseEvent e)
			{	int ind=gameList.getSelectedIndex();
				printMessage.setText(messages[ind]);
			}
	    	public void mousePressed(MouseEvent e){}
			public void mouseReleased(MouseEvent e){}
			public void mouseEntered(MouseEvent e){}
			public void mouseExited(MouseEvent e){}
		};
		gameList.addMouseListener(helpListener);
	}
	public boolean randomized()
	{	return randomize.isSelected();
	}
	public String gameName()
	{	return gameList.getSelectedValue().toString();
	}
	public String gameMap()
	{	if(chosen==2||chosen==22)
		{	for(int i=0;i<3;i++)
				if(twoPlayerBoards[i].isSelected())
					return twoPlayerBoards[i].getText();
			return "Classic";
		}
		if(chosen==4)
		{	for(int i=0;i<2;i++)
				if(fourPlayerBoards[i].isSelected())
					return fourPlayerBoards[i].getText();
			return "Classic Four Player";
		}
		return "None";
	}
	public boolean anyBoard()
	{	return gameMap()!="None"&&gameName()!="None";
	}
	public Board gameBoard()
	{	String g=gameName(),m=gameMap();
		boolean r=randomized();
		return SavedBoards.genFromStrings(m,r,g);
	}
}