import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextField;
public class SeekList extends JPanel
{	ArrayList numbers; //Integer
	ArrayList names,gameTypes,maps; //String
	ArrayList randomized; //Boolean
	JButton byName,byType,byMap,newGame;
	JList seekList;
	JPanel buttonPanel,txtPanel,seekNewGamePanel,sortByPanel;
	JTextField sortByTxt,seekTxt;
	int sortBy;
	Console console;
	MouseListener seekListener;
	String lastUpdate;
	static final long serialVersionUID=(long)0.0;
	public SeekList(String s,Console c)
	{	console=c;
		sortBy=1;
		byName=new JButton("Name");
		byType=new JButton("Type");
		byMap=new JButton("Map");
		newGame=new JButton("New Game");
		byName.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	changeSort(1);
			}
		});
		byType.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	changeSort(2);
			}
		});
		byMap.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	changeSort(3);
			}
		});
		newGame.addActionListener(new ActionListener()
		{	public void actionPerformed(ActionEvent e)
			{	new NewGameMenu(console.client);
			}
		});
		seekListener=new MouseListener()
		{	public void mouseClicked(MouseEvent e)
			{	if(numbers.size()>0)
				{	int ind=seekList.getSelectedIndex(),seekNum;
					seekNum=getNumbers(ind);
					console.client.accpetSeek(seekNum);
				}
			}
	    	public void mousePressed(MouseEvent e){}
			public void mouseReleased(MouseEvent e){}
			public void mouseEntered(MouseEvent e){}
			public void mouseExited(MouseEvent e){}
		};
		seekTxt=new JTextField();
		seekTxt.setEditable(false);
		seekTxt.setText("Seeks");
		seekTxt.setFont(new Font("Arial",Font.BOLD,14));
		sortByTxt=new JTextField();
		sortByTxt.setEditable(false);
		sortByTxt.setText("Sort By:");
		seekNewGamePanel=new JPanel();
		seekNewGamePanel.setLayout(new BorderLayout());
		seekNewGamePanel.add(newGame,"East");
		seekNewGamePanel.add(seekTxt,"Center");
		txtPanel=new JPanel();
		txtPanel.setLayout(new BorderLayout());
		txtPanel.add(seekNewGamePanel);
		txtPanel.add(sortByTxt,"South");
		buttonPanel=new JPanel();
		buttonPanel.setLayout(new FlowLayout());
		buttonPanel.add(byName);
		buttonPanel.add(byType);
		buttonPanel.add(byMap);
		update(s);
	}
	public void packStuff()
	{	seekList=new JList(getSeekList());
		seekList.setVisibleRowCount(10);
		seekList.addMouseListener(seekListener);
		removeAll();
		setLayout(new BorderLayout());
		add(txtPanel,"North");
		add(buttonPanel);
		add(new JScrollPane(seekList),"South");
	}
	public void update(String s)
	{	lastUpdate=s;
		String tokens[]=s.split("~");
		clearAllLists();
		if(tokens.length>1)
		{	for(int i=0;i<tokens.length;i++)
			{	Integer numb=Integer.valueOf(tokens[i]);
				String nam,gt,mp;
				nam=tokens[++i];
				gt=tokens[++i];
				mp=tokens[++i];
				Boolean rand=Boolean.valueOf(tokens[++i]);
				if(!nam.equals(console.client.name))
				{	numbers.add(numb);
					names.add(nam);
					gameTypes.add(gt);
					maps.add(mp);
					randomized.add(rand);
				}
			}
		}
		bubbleSort();
	}
	public void bubbleSort()
	{	for(int i=1;i<numbers.size();i++)
			for(int j=0;j<numbers.size()-i;j++)
				if(bigger(j,j+1))swap(j,j+1);
		packStuff();
	}
	public void clearAllLists()
	{	numbers=new ArrayList(); //<Integer>
		names=new ArrayList(); //<String>
		maps=new ArrayList(); //<String>
		gameTypes=new ArrayList();
		randomized=new ArrayList();
	}
	public boolean bigger(int i,int j)
	{	int mc=((String)maps.get(i)).compareToIgnoreCase((String)maps.get(j)),
		tc=((String)gameTypes.get(i)).compareToIgnoreCase((String)gameTypes.get(j));
		boolean nb=((String)names.get(i)).compareToIgnoreCase((String)names.get(j))>0,mb,tb;
		mb=mc>0||(mc==0&&nb);
		tb=tc>0||(tc==0&&nb);
		if(sortBy==1)return nb;
		if(sortBy==2)return tb;
		if(sortBy==3)return mb;
		return false;
	}
	public void swap(int i,int j)
	{	Integer tempNumber=(Integer)numbers.get(i);
		String tempName,tempMap,tempType;
		tempName=(String)names.get(i);
		tempMap=(String)maps.get(i);
		tempType=(String)gameTypes.get(i);
		Boolean tempRand=(Boolean)randomized.get(i);
		numbers.set(i,numbers.get(j));
		names.set(i,names.get(j));
		maps.set(i,maps.get(j));
		gameTypes.set(i,gameTypes.get(j));
		randomized.set(i,randomized.get(j));
		numbers.set(j,tempNumber);
		names.set(j,tempName);
		maps.set(j,tempMap);
		gameTypes.set(j,tempType);
		randomized.set(j,tempRand);
	}
	public void changeSort(int i)
	{	sortBy=i;
		bubbleSort();
		packStuff();
	}
	public int getNumbers(int index)
	{	return ((Integer)numbers.get(index)).intValue();
	}
	public String[] getSeekList()
	{	String t="      ",n,g,m;
		int l=names.size();
		String[] i=new String[l];
		for(int j=0;j<l;j++)
		{	n=(String)names.get(j);
			g=(String)gameTypes.get(j);
			m=(String)maps.get(j);
			if(((Boolean)randomized.get(j)).booleanValue())m+="(r)";
			i[j]=n+t+g+t+m;
		}
		return i;
	}
	public void reUpdate()
	{	update(lastUpdate);
	}
}
