public class Square
{
	int x,y,color;
	Board board;
	String name;
	boolean hasMoved;
	public Square(){}
	public Square(int i, int j, Board b, int c,String type)
	{	x=i;y=j;
		board=b;
		name=type;
		color=c;
		hasMoved=false;
	}
	public Square returnClone(Board b)
	{	Square s=new Square(x,y,b,color,name);
		s.hasMoved=hasMoved;
		return s;
	}
	public boolean equals(Square s)
	{	if(x!=s.x||y!=s.y)return false;
		if(!name.equals(s.name))return false;
		return hasMoved==s.hasMoved;
	}
	public void setXY(int i, int j)
	{	x=i;y=j;
	}
	
	//Square testing
	public boolean onBoard(int i, int j)
	{	if(i<0||j<0)return false;
		return !(i>=height()||j>=width());
	}
	public boolean empty()
	{	return name.equals("Empty");
	}
	public boolean canCapture()
	{	if(name.equals("Mountain"))
			return false;
		if(board.gameType.equals("Revenge"))
		{	boolean enemy=color==board.attacker(board.turn);
			if(enemy||empty())
				return false;
		}
		if(board.gameType.equals("Partners"))
		{	int t=board.turn,c=color;
			if(c==1&&t==2)return false;
			if(c==2&&t==1)return false;
			if(c==3&&t==4)return false;
			if(c==4&&t==3)return false;
		}
		return true;
	}
	public boolean stuck()
	{	for(int c=1;c<=board.players;c++)
			if(c!=turn())
				if(inRange(x,y,1,"Lover",c)&&!name.equals("Lover"))
					return true;
		return false;
	}
	public boolean mindControled()
	{	return inRange(x,y,1,"Psychic",turn());
	}
	
	//Range testing
	public static boolean squareInRange(int a,int b,int i,int j,int range)
	{	return !(Math.abs(a-i)>range||Math.abs(b-j)>range);
	}
	public static int distanceFrom(int a,int b,int i,int j)
	{	for(int c=1;c<20;c++)
			if(squareInRange(a,b,i,j,c))return c;
		return 99;
	}
	public boolean inRange(int i,int j,int r,String t,int c)
	{	for(int a=i-r;a<=i+r;a++)
			for(int b=j-r;b<=j+r;b++)
			{	boolean ret=onBoard(a, b);
				if(ret)
				{	boolean ct,cc;
					Square q=sq(a,b);
					ct=q.name.equals(t)||(t.equals("any")&&!q.empty());
					cc=q.color==c||(c==99&&!q.empty());
					ret=ret&&ct&&cc;
					if(ret)return ret;
				}
			}
		return false;
	}
	public boolean nextToForAbsorption()
	{	boolean rightType;
		int a,b;
		for(a=x-1;a<=x+1;a++)
			for(b=y-1;b<=y+1;b++)
				if(onBoard(a,b))
				{	String t=sq(a,b).name;
					rightType=!t.equals("Pawn")&&
					!t.equals("Farm")&&!t.equals("Empty");
					if(rightType)return true;
				}
		return false;
	}
	
	//	Board shortcuts
	public Square sq(int i, int j)
	{	return board.square(i, j);
	}
	public int turn()
	{	return board.turn;
	}
	public int height()
	{	return board.height;
	}
	public int width()
	{	return board.width;
	}
	
	//Movement Testing
	public boolean canMoveNoCheckTest(int i,int j)
	{	if(empty()||color==5)return false;
		String gt=board.gameType;
		if(gt.equals("Checkers")||gt.equals("Checkers Four Player"))
			if(!correctDirection(i, j)&&!onLastRow())
				return false;
		boolean r=false;
		String n=name;
		if(n.equals("Chicken"))
			r=canMoveChicken(i, j);
		else if(n.equals("Bishop"))
			r=canMoveBishop(i, j);
		else if(n.equals("Doppelganger"))
			r=canMoveDoppelganger(i, j);
		else if(n.equals("King")||n.equals("Grenade"))
			r=canMoveKing(i, j)||canCastle(i,j);
		else if(n.equals("Knight"))
			r=canMoveKnight(i, j);
		else if(n.equals("Lover"))
			r=canMoveBishop(i, j)&&sq(i,j).empty();
		else if(n.equals("Queen"))
			r=canMoveQueen(i, j);
		else if(n.equals("Pawn"))
			r=canMovePawn(i, j);
		else if(n.equals("Penguin"))
			r=canMovePenguin(i, j);
		else if(n.equals("Phoenix"))
			r=canMoveRook(i, j)||canMoveKnight(i, j);
		else if(n.equals("Psychic"))
			r=canMoveRook(i, j)&&sq(i,j).empty();
		else if(n.equals("Rook"))
			r=canMoveRook(i, j);
		else if(n.equals("Tank"))
			r=canMoveTank(i, j);
		return r;
	}
	public boolean canMove(int i,int j)
	{	String gt=board.gameType;
		if(gt.equals("Checkless"))
			if(!checklessOk(i,j))return false;
		boolean r=canMoveNoCheckTest(i,j);
		if(r)if(!board.alternateWin())
		{	Board b=board.returnClone();
			b.noCheck=true;
			Square sq1=b.square(x,y),sq2=b.square(i, j);
			b.moveOnly(x, y, i, j);
			if(sq1.name.equals("Penguin"))
				b.spawnPiece(x,y,sq2.name,sq2.color);
			if(b.inCheck())return false;
		}
		if(gt.equals("Chaos"))if(board.move==1&&turn()==1&&r)
		{	Board b=board.returnClone();
			b.noCheck=true;
			b.move(x, y, i, j);
			if(b.inCheck())return false;
		}
		return r;
	}
	public boolean moveable(int i, int j)
	{	Square sq2=sq(i,j);
		if(!sq2.canCapture())return false;
		if(needSuicideCapture(i,j))return false;
		if(sq2.color==turn())return false;
		return isMoveable();
	}
	public boolean isMoveable()
	{	if(board.gameType.equals("Power"))
		{	Board b=board.returnClone();
			b.gameType="Regular";
			boolean sp=b.squareProtected(x,y,turn());
			b.kill(x, y);
			sp=sp||b.squareProtected(x,y,turn());
			boolean peng=inRange(x,y,2,"Penguin",turn())&&!empty();
			if(!sp&&!peng)return false;
		}else if(!(color==turn()||mindControled()))
			return false;
		return !stuck();
	}
	public boolean canMoveKing(int i, int j)
	{	if(!moveable(i, j))return false;
		return squareInRange(x,y,i,j,1);
	}
	public boolean canMoveTank(int i, int j)
	{	if(!isMoveable())return false;
		if(i==x && j==y)return false;
		if(needSuicideCapture(i,j))return false;
		return squareInRange(x,y,i,j,1);
	}
	public boolean canMoveKnight(int i, int j)
	{	if(!moveable(i, j))return false;
		if(Math.abs(x-i)==1&&Math.abs(y-j)==2)
			return true;
		if(Math.abs(x-i)==2&&Math.abs(y-j)==1)
			return true;
		return false;
	}
	public boolean canMoveRook(int i, int j)
	{	if(!moveable(i, j))return false;
		if(!hOrV(x,y,i,j))return false;
		int sq1=x,sq2=y,dir=0;
		if(j==y)
		{	if(x<i){dir=1;sq1++;}
			else{dir=0;sq1--;}
		}else
		{	if(y<j){dir=3;sq2++;}
			else{dir=2;sq2--;}
		}
		while(onBoard(sq1,sq2))
		{	if(sq1==i&&sq2==j)return true;
			else if(!(sq(sq1,sq2)).empty())return false;
			if(dir==0)sq1--;
			if(dir==1)sq1++;
			if(dir==2)sq2--;
			if(dir==3)sq2++;
		}
		return false;
	}
	public boolean canMoveBishop(int i, int j)
	{	if(!moveable(i, j))return false;
		if(!diag(x,y,i,j))return false;
		int sq1=x,sq2=y,dir=0;
		if(x>i)
		{	if(y<j){dir=1;sq1--;sq2++;}
			else{dir=0;sq1--;sq2--;}
		}else
		{	if(y<j){dir=3;sq1++;sq2++;}
			else{dir=2;sq1++;sq2--;}
		}
		while(onBoard(sq1,sq2))
		{	if(sq1==i&&sq2==j)return true;
			else if(!(sq(sq1,sq2)).empty())return false;
			if(dir==0){sq1--;sq2--;}
			if(dir==1){sq1--;sq2++;}
			if(dir==2){sq1++;sq2--;}
			if(dir==3){sq1++;sq2++;}
		}
		return false;
	}
	public boolean canMoveQueen(int i, int j)
	{	return canMoveRook(i,j)||canMoveBishop(i,j);
	}
	public boolean canMoveDoppelganger(int i, int j)
	{	for(int a=x-1;a<=x+1;a++)
			for(int b=y-1;b<=y+1;b++)
				if(onBoard(a,b))
				{	String t=sq(a,b).name;
					if(!t.equals("Doppelganger")&&
							!t.equals("Empty")&&!t.equals("Farm"))
					{	name=t;
						if(canMove(i, j))
						{	name="Doppelganger";
							return true;
						}
					}
				}
		name="Doppelganger";
		return false;
	}
	public boolean canMovePenguin(int i, int j)
	{	if(sq(i, j).empty())return false;
		if(i==x&&j==y)return false;
		if(sq(i,j).name.equals("King"))return false;
		if(!sq(i,j).canCapture())return false;
		if(!squareInRange(x, y, i, j, 2))return false;
		if(! (color == turn()||mindControled()))return false;
		if(needSuicideCapture(i,j))return false;
		return !stuck();
	}
	public boolean canMovePawn(int i, int j)
	{	if(!correctDirection(i, j))return false;
		boolean rookMove,rightDistance;
		rookMove=canMoveRook(i, j)&&sq(i,j).empty();
		rightDistance=distanceFrom(x,y,i,j)==2;
		if(rookMove&&rightDistance&&!hasMoved)return true;
		if(!canMoveKing(i, j))return false;
		boolean e=(board.square(i,j)).empty();
		if(i==x||j==y){if(e)return true;}
		else if(!e)return true;
		return false;
	}
	public boolean canMoveChicken(int i, int j)
	{	if(!(canMoveBishop(i, j)||canMoveKnight(i, j)))return false;
		return inRange(i,j,1,"any",turn());
	}
	public boolean checklessOk(int i, int j)
	{	boolean ret=true;
		board.gameType="Regular";
		if(movingToWouldCheck(i,j))ret=false;
		board.gameType="Checkless";
		return ret;
	}
	public boolean movingToWouldCheck(int i, int j)
	{	Board b=board.returnClone();
		b.move(x, y, i, j);
		if(!b.inCheckmate())
			if(b.inCheck())return true;
		return false;
	}
	public boolean canCastle(int i,int j)
	{	if(!name.equals("King"))return false;
		if(!moveable(i,j))return false;
		if(hasMoved)return false;
		if(!sq(i,j).empty())return false;
		if(!hOrV(x,y,i,j))return false;
		int dist=distanceFrom(x,y,i,j);
		if(dist!=2)return false;
		if(board.inCheck())return false;
		if(color==1||color==2)
		{	if(j>y)
			{	if(i!=x||j!=y+2)return false;
				if(!sq(x,y+1).empty())return false;
				if(!sq(x,y+3).name.equals("Rook")||sq(x,y+3).hasMoved)
					return false;
			}else
			{	if(i!=x||j!=y-2)return false;
				if(!sq(x,y-1).empty()||!sq(x,y-3).empty())
					return false;
				if(!sq(x,y-4).name.equals("Rook")||sq(x,y-4).hasMoved)
					return false;
			}
		}else
		{	if(i>x)
			{	if(i!=x+2||j!=y)return false;
				if(!sq(x+1,y).empty())return false;
				if(!sq(x+3,y).name.equals("Rook")||sq(x+3,y).hasMoved)
					return false;
			}else
			{	if(i!=x-2||j!=y)return false;
				if(!sq(x-1,y).empty()||!sq(x-3,y).empty())
					return false;
				if(!sq(x-4,y).name.equals("Rook")||sq(x-4,y).hasMoved)
					return false;
			}
		}
		return true;
	}
	
	//Directional
	public static boolean hOrV(int a, int b, int i, int j)
	{	return (a==i||b==j)&&!(a==i&&b==j);
	}
	public static boolean diag(int a, int b, int i, int j)
	{	return (Math.abs(a-i)==Math.abs(b-j))&&!(a==i&&b==j);
	}
	public boolean correctDirection(int i, int j)
	{	int d=board.direction[color];
		if(d==1&&x<=i)return false;
		if(d==2&&x>=i)return false;
		if(d==3&&y<=j)return false;
		if(d==4&&y>=j)return false;
		return true;
	}
	public boolean onLastRow()
	{	int c=color;
		if(c==1&&x==0)return true;
		if(c==2&&x==height()-1)return true;
		if(c==3&&y==0)return true;
		if(c==4&&y==width()-1)return true;
		return false;
	}
	public boolean needSuicideCapture(int i, int j)
	{	if(board.gameType.equals("Suicide"))
		{	boolean capt=!sq(i,j).empty()&&
				!name.equals("Penguin")&&!name.equals("Tank");
			if(board.needSuicideCapture&&!capt)return true;
		}
		return false;
	}
	public String toString()
	{	String s=" ";
		return "\n"+x+s+y+s+color+s+name+s+hasMoved;
	}
}


